#include "KMotionDef.h"
#include "C:\CNC_George_CFiles\KFlop\George_Def.c"
//#include "C:\KMotion5.3.7\C Programs\KflopToKMotionCNCFunctions.c"
#include "C:\KMotion435f\C Programs\KflopToKMotionCNCFunctions.c"

#define T_Plate_Height 19.05
#define Zaxis_Offsets 2
main()
{

	// Move Z axis to touch plate

	Jog(Z_AXIS,-15);          // start moving
	while (!ReadBit(TOUCHPLATE_IO)); // wait for switch (input #8) to change
	Jog(Z_AXIS,0);		      // stop

	// Move BACKLASH_OFF
   	int j;
    float dist_to_move=5.0f;
    
        MoveRel(Z_AXIS,dist_to_move);
        while (!CheckDone(Z_AXIS));
        
    Jog(Z_AXIS,-4);          // start moving
	while (!ReadBit(TOUCHPLATE_IO)) ; // wait for switch (input #8) to change
	Jog(Z_AXIS,0);		      // stop
    
	
	// Set Fixture Offset
	int FixtureIndex;
	double NewOriginOffset,OriginOffsetZ;
	double DROx, DROy, DROz, DROa, DROb, DROc;
	
	GetFixtureIndex(&FixtureIndex);  //This ghould be 1 for G54, 2 for G55 etc.
	
	GetOriginOffset(&OriginOffsetZ, FixtureIndex, Zaxis_Offsets);
	GetDROs(&DROx, &DROy, &DROz, &DROa, &DROb, &DROc);
	
	NewOriginOffset = OriginOffsetZ + DROz - T_Plate_Height;	
	SetUserDataDouble(TMP,NewOriginOffset);
	SetVars(5201+FixtureIndex*20 + Zaxis_Offsets, 1, TMP);
	
	DoPC(PC_COMM_UPDATE_FIXTURE);
	Delay_sec(1);
	
   	float Z_Pos = 30;	//Pos in mm
   	Z_Pos = (Z_Pos-T_Plate_Height) * CNT_PER_MM_Z;
    MoveRel(Z_AXIS,Z_Pos);
    while (!CheckDone(Z_AXIS)) ;

}
